﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading.Tasks.Dataflow;
using Models.Events;
using Models.Rules;

namespace Models.Game
{
    public class Game
    {
        public Player CurrentPlayer { get; private set; }

        public Map UsedMap { get; private set; }

        private Dice Dice1 { get; }
        private Dice Dice2 { get; }

        private int Turn { get; set; }

        private Rules.Rules GameRules { get; }

        // == Events ==
        public event GameStartedEventArgs OnGameStarted;

     
        public Game(Player player, Map map)
        {
            UsedMap = map;
            CurrentPlayer = player;
            Dice1 = new Dice();
            Dice2 = new Dice(1);
            Turn = 0;
            GameRules = new Rules.Rules();
        }

        public void RollAllDice()
        {
            Dice1.Roll();
            Dice2.Roll();
        }

        public int ResultOperation(Operation o)
        {
            switch (o)
            {
                case Operation.LOWER:
                    return Dice1.IsLower(Dice2) ? Dice1.Value : Dice2.Value;

                case Operation.HIGHER:
                    return Dice1.IsLower(Dice2) ? Dice2.Value : Dice1.Value;

                case Operation.SUBTRACTION:
                    return Dice1.IsLower(Dice2) ? Dice2.Value - Dice1.Value : Dice1.Value - Dice2.Value;

                case Operation.ADDITION:
                    return Dice2.Value + Dice1.Value;

                case Operation.MULTIPLICATION:
                    return Dice2.Value * Dice1.Value;
                
                default:
                    return 0;
            }
        }

        public void PlaceResult (Cell playerChoice, int result)
        {
            if (Turn == 1 || GameRules.NearCell(playerChoice, UsedMap.Boards))
            {
                playerChoice.Value = result;
            }
        }

        public void AddToRopePath(Cell playerChoice, List<List<Cell>> ropePaths,Cell adjacente)
        {

            List<List<Cell>> possiblePaths;

            // {adjacentes} ne doit pas etre egale a {playerChoice}
            if (adjacente.Value == playerChoice.Value) return;

            // {adjacentes} doit etre croissant ou decroissant
            if ((adjacente.Value - playerChoice.Value > 1) || (adjacente.Value - playerChoice.Value < -1)) return;

            // Un nombre ne peut appartenir qu'a un seul chemin de corde
            foreach (List<Cell> paths in ropePaths)
            {
                foreach (var cells in paths)
                {
                    if (adjacente.X == cells.X && adjacente.Y == adjacente.Y)
                    {
                        possiblePaths.Add(paths);
                    }


                }

            }


            // Si {ropePaths} est vide, il faut alors creer un chemin de corde entre {playerChoice}
            if (ropePaths.Count == 0)
            {

            }
        }

    }
}
